<template>
  <CContainer class="d-flex content-center min-vh-100">
    <CRow>
      <CCol>
        <CCardGroup>
          <CCard style="min-width: 300px">
            <CCardHeader>
              <h3>Авторизация</h3>
            </CCardHeader>
            <CCardBody class="p-4">
              <CForm @submit.prevent="login">
                <CInput
                  :value="user.login"
                  placeholder="Логин"
                  autocomplete="username email"
                  :isValid="isValid.login"
                  :invalidFeedback="invalidFeedback.login"
                  :lazy="1800"
                  @input="onChange($event, 'login')"
                >
                </CInput>
                <CInput
                  :value="user.password"
                  placeholder="Пароль"
                  type="password"
                  autocomplete="current-password"
                  :isValid="isValid.password"
                  min-length="8"
                  :invalidFeedback="invalidFeedback.password"
                  :lazy="1800"
                  @input="onChange($event, 'password')"
                >
                </CInput>
                <CRow>
                  <CCol col="12">
                    <CButton
                      color="primary"
                      class="px-4"
                      type="submit"
                      :disabled="!isValid.login || !isValid.password"
                    >
                      Войти
                    </CButton>
                  </CCol>
                </CRow>
              </CForm>
            </CCardBody>
          </CCard>
        </CCardGroup>
      </CCol>
    </CRow>
  </CContainer>
</template>

<script>
export default {
  name: 'Login',
  data() {
    return {
      user: {
        login: ``,
        password: ``,
      },
      toastCounter: 0,
      isValid: {
        login: null,
        password: null,
      },
      invalidFeedback: {
        login: ` `,
        password: ` `,
      }
    }
  },
  methods: {
      login() {
          this.$store.dispatch('login', this.user)
              .catch(error => {
                  const message = error.response.data.data.error;
                  this.$store.dispatch('toast/addToast', {
                      toastInfo: message,
                      isVisibleToast: 1,
                  })
              })
      },
    onChange(value, type) {
      this.validate(value, type)
      this.user[type] = value;
    },
    validate(value, field) {
      const fieldLabel = field === 'password' ? `Пароль` : `Логин`
      this.isValid[field] = !!value
      this.invalidFeedback[field] = !value ? `Поле ${fieldLabel} не может быть пустым` : null
      if (field === 'password' && value.length < 8) {
        this.isValid[field] = !(field === 'password' && value.length < 8)
        this.invalidFeedback[field] = field === 'password' && value.length < 8 ? `Количество символов должно быть больше 8` : null
      }
    }
  },
}
</script>
